/*
 * Copyright (c) 2003, Morpho Project.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *
 * 1. Redistributions of source code must retain the above copyright notice,
 *    this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright notice,
 *    this list of conditions and the following disclaimer in the documentation
 *    and/or other materials provided with the distribution.
 * 3. Neither the name of the Morpho Project nor the names of its contributors
 *    may be used to endorse or promote products derived from this software
 *    without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
 * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE
 * LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
 * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
 * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
 * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
 * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
 * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
 * POSSIBILITY OF SUCH DAMAGE.
 */
package jp.morpho.util;

import java.util.Collection;
import java.util.Map;
import java.util.Set;

/**
 * <P>
 * マップに対して変更を加えたい開発者の手でサブクラス化による拡張を可能とする、Map インタフェースの簡易な実装を提供します。
 * このクラスは、ラッパーまたはデコレータのパターンに基づいて実装されています。
 * 各メソッドは、ラップされたマップオブジェクトのメソッドをデフォルトで呼び出します。
 * </P>
 * @author Kenichi Fukuda
 */
public class MapWrapper
	implements Map
{

	//ラップされるマップ
	private Map wrapped = null;

	/**
	 * <P>
	 * 指定されたマップをラップしたマップオブジェクトを構築します。
	 * </P>
	 * @param map ラップされるマップ
	 * @exception IllegalArgumentException マップが null の場合
	 */
	public MapWrapper(Map map)
	{
		super();

		//マップが null の場合は IllegalArgumentException をスローします
		if (map == null)
		{
			throw new IllegalArgumentException("map must not null");
		}

		this.wrapped = map;
	}

	/**
	 * <P>
	 * このメソッドのデフォルトの動作は、ラップされたマップオブジェクトに対し size() を呼び出すことです。
	 * <P>
	 * @see java.util.Map#size()
	 */
	public synchronized int size()
	{
		return wrapped.size();
	}

	/**
	 * <P>
	 * このメソッドのデフォルトの動作は、ラップされたマップオブジェクトに対し isEmpty() を呼び出すことです。
	 * <P>
	 * @see java.util.Map#isEmpty()
	 */
	public synchronized boolean isEmpty()
	{
		return wrapped.isEmpty();
	}

	/**
	 * <P>
	 * このメソッドのデフォルトの動作は、ラップされたマップオブジェクトに対し containsKey(Object) を呼び出すことです。
	 * <P>
	 * @see java.util.Map#containsKey(Object)
	 */
	public synchronized boolean containsKey(Object key)
	{
		return wrapped.containsKey(key);
	}

	/**
	 * <P>
	 * このメソッドのデフォルトの動作は、ラップされたマップオブジェクトに対し containsValue(Object) を呼び出すことです。
	 * <P>
	 * @see java.util.Map#containsValue(Object)
	 */
	public synchronized boolean containsValue(Object key)
	{
		return wrapped.containsValue(key);
	}

	/**
	 * <P>
	 * このメソッドのデフォルトの動作は、ラップされたマップオブジェクトに対し get(Object) を呼び出すことです。
	 * <P>
	 * @see java.util.Map#get(Object)
	 */
	public synchronized Object get(Object key)
	{
		return wrapped.get(key);
	}

	/**
	 * <P>
	 * このメソッドのデフォルトの動作は、ラップされたマップオブジェクトに対し put(Object, Object) を呼び出すことです。
	 * <P>
	 * @see java.util.Map#put(Object, Object)
	 */
	public synchronized Object put(Object key, Object value)
	{
		return wrapped.put(key, value);
	}

	/**
	 * <P>
	 * このメソッドのデフォルトの動作は、ラップされたマップオブジェクトに対し remove(Object) を呼び出すことです。
	 * <P>
	 * @see java.util.Map#remove(Object)
	 */
	public synchronized Object remove(Object key)
	{
		return wrapped.remove(key);
	}

	/**
	 * <P>
	 * このメソッドのデフォルトの動作は、ラップされたマップオブジェクトに対し putAll(Map) を呼び出すことです。
	 * <P>
	 * @see java.util.Map#putAll(Map)
	 */
	public synchronized void putAll(Map map)
	{
		wrapped.putAll(map);
	}

	/**
	 * <P>
	 * このメソッドのデフォルトの動作は、ラップされたマップオブジェクトに対し clear() を呼び出すことです。
	 * <P>
	 * @see java.util.Map#clear()
	 */
	public synchronized void clear()
	{
		wrapped.clear();
	}

	/**
	 * <P>
	 * このメソッドのデフォルトの動作は、ラップされたマップオブジェクトに対し keySet() を呼び出すことです。
	 * <P>
	 * @see java.util.Map#keySet()
	 */
	public synchronized Set keySet()
	{
		return wrapped.keySet();
	}

	/**
	 * <P>
	 * このメソッドのデフォルトの動作は、ラップされたマップオブジェクトに対し values() を呼び出すことです。
	 * <P>
	 * @see java.util.Map#values()
	 */
	public synchronized Collection values()
	{
		return wrapped.values();
	}

	/**
	 * <P>
	 * このメソッドのデフォルトの動作は、ラップされたマップオブジェクトに対し entrySet() を呼び出すことです。
	 * <P>
	 * @see java.util.Map#entrySet()
	 */
	public synchronized Set entrySet()
	{
		return wrapped.entrySet();
	}

}
